unit DBTrackTarget_DTEdit;

{<
  DBTrackTarget_DTEdit is design time dialog used by DBTrackTarget component.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
  @lastmod(Apr 2017)
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, db, ComCtrls, rImprovedComps;

type
  { design time dialog used by DBTrack component }
  TDBTrackTarget_DTEditForm = class(TForm)
    pc: TPageControl;
    tsCol: TTabSheet;
    cbDateTime: TrComboBoxEx;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbUser: TrComboBoxEx;
    Label4: TLabel;
    cbAction: TrComboBoxEx;
    Label5: TLabel;
    cbTableName: TrComboBoxEx;
    Label6: TLabel;
    cbKeyValue: TrComboBoxEx;
    Label7: TLabel;
    cbChanges: TrComboBoxEx;
    Label8: TLabel;
    cbMemo: TrComboBoxEx;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    cbSpecial: TrComboBoxEx;
    Label18: TLabel;
    btClose: TButton;
    Label19: TLabel;
    Label20: TLabel;
    cbCustomMemo: TrComboBoxEx;
    procedure FormShow(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FFields: TStrings;
    procedure LoadProps;
    procedure SetProps;
  public
  end;

{ initialize and show design time dialog }
function ShowDBTrackTargetEditor(Component: TComponent): boolean;

implementation

{$R *.dfm}

uses TypInfo, rtool, rdlg, rdbtool;

function ShowDBTrackTargetEditor(Component: TComponent): boolean;
var
  F: TDBTrackTarget_DTEditForm;
  DS: TDataSet;
begin
  Result:=true;
  F:=TDBTrackTarget_DTEditForm.Create(Application);
  try
    F.Caption:=Component.Name;
    F.FFields.Clear;
    try
      DS:=GetObjectProp(Component, 'TargetDataSet') as TDataSet;
      GetFldList(DS, F.FFields, [fdAllField]);
    except
    end;
    F.cbDateTime.Text:=GetStrProp(Component, 'FieldDateTime');
    F.cbDateTime.Items.Assign(F.FFields);
    F.cbUser.Text:=GetStrProp(Component, 'FieldUser');
    F.cbUser.Items.Assign(F.FFields);
    F.cbAction.Text:=GetStrProp(Component, 'FieldAction');
    F.cbAction.Items.Assign(F.FFields);
    F.cbTableName.Text:=GetStrProp(Component, 'FieldTableName');
    F.cbTableName.Items.Assign(F.FFields);
    F.cbKeyValue.Text:=GetStrProp(Component, 'FieldKeyValue');
    F.cbKeyValue.Items.Assign(F.FFields);
    F.cbChanges.Text:=GetStrProp(Component, 'FieldChanges');
    F.cbChanges.Items.Assign(F.FFields);
    F.cbMemo.Text:=GetStrProp(Component, 'FieldMemo');
    F.cbMemo.Items.Assign(F.FFields);
    F.cbCustomMemo.Text:=GetStrProp(Component, 'FieldCustomMemo');
    F.cbCustomMemo.Items.Assign(F.FFields);
    F.cbSpecial.Text:=GetStrProp(Component, 'FieldSpecial');
    F.cbSpecial.Items.Assign(F.FFields);

    F.ShowModal;

    SetStrProp(Component, 'FieldDateTime', F.cbDateTime.Text);
    SetStrProp(Component, 'FieldUser', F.cbUser.Text);
    SetStrProp(Component, 'FieldAction', F.cbAction.Text);
    SetStrProp(Component, 'FieldTableName', F.cbTableName.Text);
    SetStrProp(Component, 'FieldKeyValue', F.cbKeyValue.Text);
    SetStrProp(Component, 'FieldChanges', F.cbChanges.Text);
    SetStrProp(Component, 'FieldMemo', F.cbMemo.Text);
    SetStrProp(Component, 'FieldCustomMemo', F.cbCustomMemo.Text);
    SetStrProp(Component, 'FieldSpecial', F.cbSpecial.Text);
  finally
    FreeAndNil(F);
  end;
end;

procedure TDBTrackTarget_DTEditForm.FormCreate(Sender: TObject);
begin
  FFields:=TStringList.Create;
end;

procedure TDBTrackTarget_DTEditForm.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FFields);
end;

procedure TDBTrackTarget_DTEditForm.FormShow(Sender: TObject);
begin
  pc.ActivePageIndex:=0;
  LoadProps;
end;

procedure TDBTrackTarget_DTEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetProps;
end;

procedure TDBTrackTarget_DTEditForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TDBTrackTarget_DTEditForm.LoadProps;
begin ;
end;

procedure TDBTrackTarget_DTEditForm.SetProps;
begin ;
end;

end.
